import { CFString, Value, LiteralOrRef, CFList, CFMap, BooleanCondition, CFBoolean, CFInteger } from "./core";
import { ConditionId } from "./template";
export interface Base64 {
    'Fn::Base64': Value<CFString>;
}
export declare function Base64(v: Base64['Fn::Base64']): Base64 & Value<CFString>;
export interface FindInMap {
    'Fn::FindInMap': [Value<CFString>, Value<CFString>, Value<CFString>];
}
export declare function FindInMap<V>(v: FindInMap['Fn::FindInMap']): FindInMap & Value<V>;
export interface GetAtt {
    'Fn::GetAtt': [CFString, LiteralOrRef<CFString>];
}
export declare function GetAtt<V>(v: GetAtt['Fn::GetAtt']): GetAtt & Value<V>;
export interface GetAZs {
    'Fn::GetAZs': LiteralOrRef<CFString>;
}
export declare function GetAZs(v: GetAZs['Fn::GetAZs']): GetAZs & Value<CFList<CFString>>;
export interface ImportValue {
    'Fn::ImportValue': Value<CFString>;
}
export declare function ImportValue<V>(v: ImportValue['Fn::ImportValue']): ImportValue & Value<V>;
export interface Join {
    'Fn::Join': [CFString, Value<Array<Value<CFString>>>];
}
export declare function Join(v: Join['Fn::Join']): Join & Value<CFString>;
export interface Select<V> {
    'Fn::Select': [Value<CFInteger>, Value<CFList<Value<V>>>];
}
export declare function Select<V>(v: Select<V>['Fn::Select']): Select<V> & Value<V>;
export interface Split {
    'Fn::Split': [CFString, Value<CFString>];
}
export declare function Split(v: Split['Fn::Split']): Split & Value<CFList<CFString>>;
export interface Sub {
    'Fn::Sub': [Value<CFString>, Value<CFMap<Value<CFString>>>] | Value<CFString>;
}
export declare function Sub(v: Sub['Fn::Sub']): Sub & Value<CFString>;
export interface And {
    'Fn::And': CFList<BooleanCondition>;
}
export declare function And(v: And['Fn::And']): And & Value<CFBoolean>;
export interface Equals {
    'Fn::Equals': [Value<any>, Value<any>];
}
export declare function Equals(v: Equals['Fn::Equals']): Equals & Value<CFBoolean>;
export interface If<V> {
    'Fn::If': [ConditionId, Value<V>, Value<V>];
}
export declare function If<V>(v: If<V>['Fn::If']): If<V> & Value<V>;
export interface Not {
    'Fn::Not': [BooleanCondition];
}
export declare function Not(v: Not['Fn::Not']): Not & Value<CFBoolean>;
export interface Or {
    'Fn::Or': Array<BooleanCondition>;
}
export declare function Or(v: Or['Fn::Or']): Or & Value<CFBoolean>;
